from pbrutils import split_angle,deg2dms,DMS2str
from pbrutils import calcAzimuth,calcDistance,calcDiff2Angle
from pbrutils import calcNextAzimuth,shortest_distance_point_to_plane
from pbrutils import calcIntersectionAzimuthAzimuth,equation_plane
from pbrutils import PI,DEG2RAD,RAD2DEG,mean,calcNextCoordinate2D
from pbrutils import distance_point_to_3Dline
import math


def print_menu():
  print('COGO Selected Serie 3')
  print('1:OS Point to Line')
  print('2:OS Point from Line')
  print('3:OS Point to Plane')
  print('4:OS Point to 3D Line')
  print('5:Exit')

def offset_point_to_line():
  print('O/S point to 2D line.')
  print("Input Line:")
  n1=float(input("N1=?" ))
  e1=float(input("E1=?" ))
  n2=float(input("N2=?" ))
  e2=float(input("E2=?" ))
  print("Input point:")
  n3=float(input("N3=?" ))
  e3=float(input("E3=?" ))
  azimuth12=calcAzimuth(n1,e1,n2,e2)
  azimuthper=calcNextAzimuth(0.5*PI,azimuth12)
  ni,ei=calcIntersectionAzimuthAzimuth([n1,e1],azimuth12,[n3,e3],azimuthper)
  os=calcDistance(ni,ei,n3,e3)
  ch=calcDistance(ni,ei,n1,e1)
  print("Offset dist= {0:.3f}".format(os))
  print("Chainage= {0:.3f}".format(ch))
  print("N=","{0:.3f}".format(ni))
  print("E=","{0:.3f}".format(ei))
  input("Press any key")  

def offset_point_from_line():
  f=True
  print("O/S point from 2D line.")
  print("Input Line:")
  n1=float(input("N1=?" ))
  e1=float(input("E1=?" ))
  n2=float(input("N2=?" ))
  e2=float(input("E2=?" ))
  while f:
    print("Input chainage & dist")
    ch=float(input("Chainage=?"))
    print("Input offset distance.")
    print("- left and + right")
    os=float(input("Offset dist=?"))
    azimuth12=calcAzimuth(n1,e1,n2,e2)
    if os<0:
      azimuthper=calcNextAzimuth(0.5*math.pi,azimuth12)
    else:
      azimuthper=calcNextAzimuth(1.5*math.pi,azimuth12)
    ni=n1+math.cos(azimuth12)*ch
    ei=e1+math.sin(azimuth12)*ch
    nos=ni+math.cos(azimuthper)*abs(os)
    eos=ei+math.sin(azimuthper)*abs(os)
    print("Offset pt coordinates:")
    print("N= {:.3f}".format(nos))
    print("E= {:.3f}".format(eos))
    con = input("Continue (Y/N)?")
    if con=="Y" or con=="y":
      f=True
    else:
      f=False

def offset_point_to_plane():
  print("O/S pt to 3D plane.")
  print("Input 3 pts for plane:")
  n1=float(input("N1=?" ))
  e1=float(input("E1=?" ))
  z1=float(input("Z1=?"))
  n2=float(input("N2=?" ))
  e2=float(input("E2=?" ))
  z2=float(input("Z2=?"))
  n3=float(input("N3=?" ))
  e3=float(input("E3=?" ))
  z3=float(input("Z3=?"))
  print("Input pt to project.")
  n4=float(input("N=?" ))
  e4=float(input("E=?" ))  
  z4=float(input("Z=?"))
  a,b,c,d=equation_plane(n1,e1,z1,n2,e2,z2,n3,e3,z3)
  shdist=shortest_distance_point_to_plane(n4,e4,z4,a,b,c,d)
  print("Shortest Distance:")
  print("Distance= {:0.3f}".format(shdist))
  input("Press any key") 

def offset_distance_point_to_3Dline():
  print("O/S point to 3D line.")
  print("Input 3D line:")
  n2=float(input("N1=?" ))
  e2=float(input("E1=?" ))
  z2=float(input("Z1=?"))
  n3=float(input("N2=?" ))
  e3=float(input("E2=?" ))
  z3=float(input("Z2=?"))
  print("Input pt to project.")
  n1=float(input("N=?" ))
  e1=float(input("E=?" ))  
  z1=float(input("Z=?"))
  os=distance_point_to_3Dline(n1,e1,z1,n2,e2,z2,n3,e3,z3)
  print("Offset dist= {:.3f}".format(os))
  input("Press any key")  

loop=True
choice=-1
ex_choice=-1
while loop:      
  print_menu()
  choice=int(input('Selection[1-5]'))  
  if (choice==5):
    loop=False
  elif (choice==1):
    loop=True
    offset_point_to_line()
    ex_choice=1
  elif (choice==2):
    loop=True
    offset_point_from_line()
    ex_choice=2
  elif (choice==3):
    offset_point_to_plane()
    loop=True
    ex_choice=3
  elif (choice==4):
    loop=True
    offset_distance_point_to_3Dline()
    ex_choice=4